=== modified file 'Makefile'
--- Makefile	2008-07-21 01:50:31 +0000
+++ Makefile	2008-07-20 03:51:41 +0000
@@ -1,20 +1,7 @@
 CFLAGS=-Wall -g -std=gnu99
-
-PROGS=plugbasedclient plugins.d/mandosclient plugins.d/passprompt
-
-objects=$(shell for p in $(PROGS); do echo $${p}.o; done)
-
-all: $(PROGS)
-
-plugbasedclient: plugbasedclient.o
-	$(LINK.o) -lgnutls $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-plugins.d/mandosclient: plugins.d/mandosclient.o
-	$(LINK.o) -lgnutls -lavahi-core -lgpgme $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-plugins.d/passprompt: plugins.d/passprompt.o
-	$(LINK.o) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
-
-.PHONY : clean
+LDFLAGS=-lgnutls
+
+all: plugbasedclient
+
 clean:
-	-rm -f $(PROGS) $(objects) core
+	rm -f plugbasedclient

=== modified file 'TODO'
--- TODO	2008-07-21 19:15:06 +0000
+++ TODO	2008-07-20 06:33:48 +0000
@@ -1,16 +1,9 @@
-[Mandos client]
-configuration for OpenPGP key
+[Client]
+configuration for OpenPGP key and interface
 IPv4 support
 
-[Pluginbasedclient]
-disable certain plugins
-change uid to nobody:nogroup
-	other drop privs stuff?
-
 [Server]
-config file for:
-	TXT record
-	GnuTLS priority string
+config file
 run-time communication with server
 
 [Mandos-tools/utilities]

=== added file 'plugins.d/Makefile'
--- plugins.d/Makefile	1970-01-01 00:00:00 +0000
+++ plugins.d/Makefile	2008-07-20 02:52:20 +0000
@@ -0,0 +1,18 @@
+CFLAGS=-Wall -g --std=gnu99
+LDFLAGS=-lgnutls -lavahi-core -lgpgme
+
+PROGS=mandosclient passprompt
+
+objects=mandosclient.o passprompt.o
+
+all: $(PROGS)
+
+mandosclient: mandosclient.o
+	$(LINK.o) -lgnutls -lavahi-core -lgpgme $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+
+passprompt: passprompt.o
+	$(LINK.o) $(COMMON) $^ $(LOADLIBES) $(LDLIBS) -o $@
+
+.PHONY : clean
+clean :
+	-rm -f $(PROGS) $(objects) core

=== modified file 'plugins.d/mandosclient.c'
--- plugins.d/mandosclient.c	2008-07-21 19:15:06 +0000
+++ plugins.d/mandosclient.c	2008-07-20 02:52:20 +0000
@@ -1,3 +1,16 @@
+/* $Id$ */
+
+/* PLEASE NOTE *
+ * This file demonstrates how to use Avahi's core API, this is
+ * the embeddable mDNS stack for embedded applications.
+ *
+ * End user applications should *not* use this API and should use
+ * the D-Bus or C APIs, please see
+ * client-browse-services.c and glib-integration.c
+ * 
+ * I repeat, you probably do *not* want to use this example.
+ */
+
 /***
   This file is part of avahi.
  
@@ -50,8 +63,6 @@
 #include <errno.h>		/* perror() */
 #include <gpgme.h>
 
-// getopt long
-#include <getopt.h>
 
 #ifndef CERT_ROOT
 #define CERT_ROOT "/conf/conf.d/cryptkeyreq/"
@@ -61,9 +72,6 @@
 #define BUFFER_SIZE 256
 #define DH_BITS 1024
 
-bool debug = false;
-char *interface = "eth0";
-
 typedef struct {
   gnutls_session_t session;
   gnutls_certificate_credentials_t cred;
@@ -80,10 +88,6 @@
   size_t new_packet_length = 0;
   gpgme_engine_info_t engine_info;
 
-  if (debug){
-    fprintf(stderr, "Attempting to decrypt password from gpg packet\n");
-  }
-  
   /* Init GPGME */
   gpgme_check_version(NULL);
   gpgme_engine_check_version(GPGME_PROTOCOL_OpenPGP);
@@ -139,37 +143,27 @@
 	    gpgme_strsource(rc), gpgme_strerror(rc));
     return -1;
   }
-
-  if(debug){
-    fprintf(stderr, "decryption of gpg packet succeeded\n");
-  }
-
-  if (debug){
-    gpgme_decrypt_result_t result;
-    result = gpgme_op_decrypt_result(ctx);
-    if (result == NULL){
-      fprintf(stderr, "gpgme_op_decrypt_result failed\n");
-    } else {
-      fprintf(stderr, "Unsupported algorithm: %s\n", result->unsupported_algorithm);
-      fprintf(stderr, "Wrong key usage: %d\n", result->wrong_key_usage);
-      if(result->file_name != NULL){
-	fprintf(stderr, "File name: %s\n", result->file_name);
-      }
-      gpgme_recipient_t recipient;
-      recipient = result->recipients;
-      if(recipient){
-	while(recipient != NULL){
-	  fprintf(stderr, "Public key algorithm: %s\n",
-		  gpgme_pubkey_algo_name(recipient->pubkey_algo));
-	  fprintf(stderr, "Key ID: %s\n", recipient->keyid);
-	  fprintf(stderr, "Secret key available: %s\n",
-		  recipient->status == GPG_ERR_NO_SECKEY ? "No" : "Yes");
-	  recipient = recipient->next;
-	}
-      }
-    }
-  }
   
+/*   gpgme_decrypt_result_t result; */
+/*   result = gpgme_op_decrypt_result(ctx); */
+/*   fprintf(stderr, "Unsupported algorithm: %s\n", result->unsupported_algorithm); */
+/*   fprintf(stderr, "Wrong key usage: %d\n", result->wrong_key_usage); */
+/*   if(result->file_name != NULL){ */
+/*     fprintf(stderr, "File name: %s\n", result->file_name); */
+/*   } */
+/*   gpgme_recipient_t recipient; */
+/*   recipient = result->recipients; */
+/*   if(recipient){ */
+/*     while(recipient != NULL){ */
+/*       fprintf(stderr, "Public key algorithm: %s\n", */
+/* 	      gpgme_pubkey_algo_name(recipient->pubkey_algo)); */
+/*       fprintf(stderr, "Key ID: %s\n", recipient->keyid); */
+/*       fprintf(stderr, "Secret key available: %s\n", */
+/* 	      recipient->status == GPG_ERR_NO_SECKEY ? "No" : "Yes"); */
+/*       recipient = recipient->next; */
+/*     } */
+/*   } */
+
   /* Delete the GPGME FILE pointer cryptotext data buffer */
   gpgme_data_release(dh_crypto);
   
@@ -200,15 +194,7 @@
     new_packet_length += ret;
   }
 
-  /* FIXME: check characters before printing to screen so to not print
-     terminal control characters */
-  /*   if(debug){ */
-  /*     fprintf(stderr, "decrypted password is: "); */
-  /*     fwrite(*new_packet, 1, new_packet_length, stderr); */
-  /*     fprintf(stderr, "\n"); */
-  /*   } */
-  
-  /* Delete the GPGME plaintext data buffer */
+   /* Delete the GPGME plaintext data buffer */
   gpgme_data_release(dh_plain);
   return new_packet_length;
 }
@@ -227,11 +213,6 @@
 int initgnutls(encrypted_session *es){
   const char *err;
   int ret;
-
-  if(debug){
-    fprintf(stderr, "Initializing gnutls\n");
-  }
-
   
   if ((ret = gnutls_global_init ())
       != GNUTLS_E_SUCCESS) {
@@ -239,11 +220,10 @@
     return -1;
   }
 
-  if (debug){
-    gnutls_global_set_log_level(11);
-    gnutls_global_set_log_function(debuggnutls);
-  }
-  
+  /* Uncomment to enable full debuggin on the gnutls library */
+  /*   gnutls_global_set_log_level(11); */
+  /*   gnutls_global_set_log_function(debuggnutls); */
+
 
   /* openpgp credentials */
   if ((ret = gnutls_certificate_allocate_credentials (&es->cred))
@@ -252,11 +232,6 @@
     return -1;
   }
 
-  if(debug){
-    fprintf(stderr, "Attempting to use openpgp certificate %s"
-	    " and keyfile %s as gnutls credentials\n", CERTFILE, KEYFILE);
-  }
-
   ret = gnutls_certificate_set_openpgp_key_file
     (es->cred, CERTFILE, KEYFILE, GNUTLS_OPENPGP_FMT_BASE64);
   if (ret != GNUTLS_E_SUCCESS) {
@@ -318,9 +293,10 @@
 
 void empty_log(AvahiLogLevel level, const char *txt){}
 
-int start_mandos_communication(char *ip, uint16_t port){
+int start_mandos_communcation(char *ip, uint16_t port){
   int ret, tcp_sd;
   struct sockaddr_in6 to;
+  struct in6_addr ip_addr;
   encrypted_session es;
   char *buffer = NULL;
   char *decrypted_buffer;
@@ -329,21 +305,14 @@
   ssize_t decrypted_buffer_size;
   int retval = 0;
 
-  if(debug){
-    fprintf(stderr, "Setting up a tcp connection to %s\n", ip);
-  }
   
   tcp_sd = socket(PF_INET6, SOCK_STREAM, 0);
   if(tcp_sd < 0) {
     perror("socket");
     return -1;
   }
-
-  if(debug){
-    fprintf(stderr, "Binding to interface %s\n", interface);
-  }
-
-  ret = setsockopt(tcp_sd, SOL_SOCKET, SO_BINDTODEVICE, interface, 5);
+  
+  ret = setsockopt(tcp_sd, SOL_SOCKET, SO_BINDTODEVICE, "eth0", 5);
   if(tcp_sd < 0) {
     perror("setsockopt bindtodevice");
     return -1;
@@ -351,7 +320,7 @@
   
   memset(&to,0,sizeof(to));
   to.sin6_family = AF_INET6;
-  ret = inet_pton(AF_INET6, ip, &to.sin6_addr);
+  ret = inet_pton(AF_INET6, ip, &ip_addr);
   if (ret < 0 ){
     perror("inet_pton");
     return -1;
@@ -361,11 +330,7 @@
     return -1;
   }
   to.sin6_port = htons(port);
-  to.sin6_scope_id = if_nametoindex(interface);
-
-  if(debug){
-    fprintf(stderr, "Connection to: %s\n", ip);
-  }
+  to.sin6_scope_id = if_nametoindex("eth0");
   
   ret = connect(tcp_sd, (struct sockaddr *) &to, sizeof(to));
   if (ret < 0){
@@ -382,11 +347,6 @@
   
   gnutls_transport_set_ptr (es.session, (gnutls_transport_ptr_t) tcp_sd);
 
-  if(debug){
-    fprintf(stderr, "Establishing tls session with %s\n", ip);
-  }
-
-  
   ret = gnutls_handshake (es.session);
   
   if (ret != GNUTLS_E_SUCCESS){
@@ -396,12 +356,7 @@
     goto exit;
   }
 
-  //Retrieve gpg packet that contains the wanted password
-
-  if(debug){
-    fprintf(stderr, "Retrieving pgp encrypted password from %s\n", ip);
-  }
-
+  //retrive password
   while(true){
     if (buffer_length + BUFFER_SIZE > buffer_capacity){
       buffer = realloc(buffer, buffer_capacity + BUFFER_SIZE);
@@ -441,23 +396,19 @@
       buffer_length += ret;
     }
   }
-  
+
   if (buffer_length > 0){
-    if ((decrypted_buffer_size = gpg_packet_decrypt(buffer, buffer_length, &decrypted_buffer, CERT_ROOT)) >= 0){
+    if ((decrypted_buffer_size = gpg_packet_decrypt(buffer, buffer_length, &decrypted_buffer, CERT_ROOT)) == 0){
+      retval = -1;
+    } else {
       fwrite (decrypted_buffer, 1, decrypted_buffer_size, stdout);
       free(decrypted_buffer);
-    } else {
-      retval = -1;
     }
   }
 
+  free(buffer);
+
   //shutdown procedure
-
-  if(debug){
-    fprintf(stderr, "Closing tls session\n");
-  }
-
-  free(buffer);
   gnutls_bye (es.session, GNUTLS_SHUT_RDWR);
  exit:
   close(tcp_sd);
@@ -497,10 +448,7 @@
         case AVAHI_RESOLVER_FOUND: {
 	  char ip[AVAHI_ADDRESS_STR_MAX];
             avahi_address_snprint(ip, sizeof(ip), address);
-	    if(debug){
-	      fprintf(stderr, "Mandos server found at %s on port %d\n", ip, port);
-	    }
-	    int ret = start_mandos_communication(ip, port);
+	    int ret = start_mandos_communcation(ip, port);
 	    if (ret == 0){
 	      exit(EXIT_SUCCESS);
 	    } else {
@@ -559,36 +507,9 @@
     AvahiServerConfig config;
     AvahiSServiceBrowser *sb = NULL;
     int error;
-    int ret;
-    int returncode = EXIT_SUCCESS;
-
-    while (true){
-      static struct option long_options[] = {
-	{"debug", no_argument, (int *)&debug, 1},
-	{"interface", required_argument, 0, 'i'},
-	{0, 0, 0, 0} };
-
-      int option_index = 0;
-      ret = getopt_long (argc, argv, "i:", long_options, &option_index);
-
-      if (ret == -1){
-	break;
-      }
-      
-      switch(ret){
-      case 0:
-	break;
-      case 'i':
-	interface = optarg;
-	break;
-      default:
-	exit(EXIT_FAILURE);
-      }
-    }
-    
-    if (not debug){
-      avahi_set_log_function(empty_log);
-    }
+    int ret = 1;
+
+    avahi_set_log_function(empty_log);
     
     /* Initialize the psuedo-RNG */
     srand(time(NULL));
@@ -596,8 +517,7 @@
     /* Allocate main loop object */
     if (!(simple_poll = avahi_simple_poll_new())) {
         fprintf(stderr, "Failed to create simple poll object.\n");
-	
-        goto exit;
+        goto fail;
     }
 
     /* Do not publish any local records */
@@ -607,39 +527,35 @@
     config.publish_workstation = 0;
     config.publish_domain = 0;
 
+/*     /\* Set a unicast DNS server for wide area DNS-SD *\/ */
+/*     avahi_address_parse("193.11.177.11", AVAHI_PROTO_UNSPEC, &config.wide_area_servers[0]); */
+/*     config.n_wide_area_servers = 1; */
+/*     config.enable_wide_area = 1; */
+    
     /* Allocate a new server */
     server = avahi_server_new(avahi_simple_poll_get(simple_poll), &config, NULL, NULL, &error);
 
     /* Free the configuration data */
     avahi_server_config_free(&config);
 
-    /* Check if creating the server object succeeded */
+    /* Check wether creating the server object succeeded */
     if (!server) {
         fprintf(stderr, "Failed to create server: %s\n", avahi_strerror(error));
-	returncode = EXIT_FAILURE;
-        goto exit;
+        goto fail;
     }
     
     /* Create the service browser */
     if (!(sb = avahi_s_service_browser_new(server, if_nametoindex("eth0"), AVAHI_PROTO_INET6, "_mandos._tcp", NULL, 0, browse_callback, server))) {
         fprintf(stderr, "Failed to create service browser: %s\n", avahi_strerror(avahi_server_errno(server)));
-	returncode = EXIT_FAILURE;
-        goto exit;
+        goto fail;
     }
     
     /* Run the main loop */
-
-    if (debug){
-      fprintf(stderr, "Starting avahi loop search\n");
-    }
-    
     avahi_simple_poll_loop(simple_poll);
     
-exit:
-
-    if (debug){
-      fprintf(stderr, "%s exiting\n", argv[0]);
-    }
+    ret = 0;
+    
+fail:
     
     /* Cleanup things */
     if (sb)
@@ -651,5 +567,5 @@
     if (simple_poll)
         avahi_simple_poll_free(simple_poll);
 
-    return returncode;
+    return ret;
 }

=== modified file 'plugins.d/passprompt.c'
--- plugins.d/passprompt.c	2008-07-21 03:58:36 +0000
+++ plugins.d/passprompt.c	2008-07-20 02:52:20 +0000
@@ -11,66 +11,29 @@
 				   SIGQUIT, SIGHUP, SIGTERM */
 #include <stddef.h>		/* NULL, size_t */
 #include <sys/types.h>		/* ssize_t */
-#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE,
-				   getopt_long */
+#include <stdlib.h>		/* EXIT_SUCCESS, EXIT_FAILURE */
 #include <stdio.h>		/* fprintf(), stderr, getline(),
 				   stdin, feof(), perror(), fputc(),
-				   stdout, getopt_long */
+				   stdout */
 #include <errno.h>		/* errno, EINVAL */
 #include <iso646.h>		/* or, not */
 #include <stdbool.h>		/* bool, false, true */
-#include <string.h> 		/* strlen, rindex, strncmp, strcmp */
-#include <getopt.h>		/* getopt_long */
 
 volatile bool quit_now = false;
-bool debug = false;
 
 void termination_handler(int signum){
   quit_now = true;
 }
 
 int main(int argc, char **argv){
-  ssize_t ret;
+  ssize_t ret = -1;
   size_t n;
   struct termios t_new, t_old;
   char *buffer = NULL;
-  char *prefix = NULL;
   int status = EXIT_SUCCESS;
   struct sigaction old_action,
     new_action = { .sa_handler = termination_handler,
 		   .sa_flags = 0 };
-
-  while (true){
-    static struct option long_options[] = {
-      {"debug", no_argument, (int *)&debug, 1},
-      {"prefix", required_argument, 0, 'p'},
-      {0, 0, 0, 0} };
-
-    int option_index = 0;
-    ret = getopt_long (argc, argv, "p:", long_options, &option_index);
-
-    if (ret == -1){
-      break;
-    }
-      
-    switch(ret){
-    case 0:
-      break;
-    case 'p':
-      prefix = optarg;
-      break;
-    default:
-      fprintf(stderr, "bad arguments\n");
-      exit(EXIT_FAILURE);
-    }
-  }
-      
-  if (debug){
-    fprintf(stderr, "Starting %s\n", argv[0]);
-  }
-  if (debug){
-    fprintf(stderr, "Storing current terminal attributes\n");
-  }
   
   if (tcgetattr(STDIN_FILENO, &t_old) != 0){
     return EXIT_FAILURE;
@@ -93,11 +56,6 @@
   sigaction(SIGTERM, NULL, &old_action);
   if (old_action.sa_handler != SIG_IGN)
     sigaction(SIGTERM, &new_action, NULL);
-
-  
-  if (debug){
-    fprintf(stderr, "Removing echo flag from terminal attributes\n");
-  }
   
   t_new = t_old;
   t_new.c_lflag &= ~ECHO;
@@ -105,21 +63,13 @@
     perror("tcsetattr-echo");
     return EXIT_FAILURE;
   }
-
-  if (debug){
-    fprintf(stderr, "Waiting for input from stdin \n");
-  }
+  
   while(true){
     if (quit_now){
       status = EXIT_FAILURE;
       break;
     }
-
-    if(prefix){
-      fprintf(stderr, "%s Password: ", prefix);
-    } else {
-      fprintf(stderr, "Password: ");
-    }      
+    fprintf(stderr, "Password: ");
     ret = getline(&buffer, &n, stdin);
     if (ret > 0){
       fprintf(stdout, "%s", buffer);
@@ -137,16 +87,9 @@
     fputc('\n', stderr);
   }
 
-  if (debug){
-    fprintf(stderr, "Restoring terminal attributes\n");
-  }
   if (tcsetattr(STDIN_FILENO, TCSAFLUSH, &t_old) != 0){
     perror("tcsetattr+echo");
   }
-
-  if (debug){
-    fprintf(stderr, "%s is exiting\n", argv[0]);
-  }
   
   return status;
 }

=== modified file 'server.py'
--- server.py	2008-07-21 01:50:31 +0000
+++ server.py	2008-07-20 06:33:48 +0000
@@ -1,34 +1,5 @@
 #!/usr/bin/python
 # -*- mode: python; coding: utf-8 -*-
-# 
-# Mandos server - give out binary blobs to connecting clients.
-# 
-# This program is partly derived from an example program for an Avahi
-# service publisher, downloaded from
-# <http://avahi.org/wiki/PythonPublishExample>.  This includes the
-# following functions: "add_service", "remove_service",
-# "server_state_changed", "entry_group_state_changed", and some lines
-# in "main".
-# 
-# Everything else is Copyright © 2007-2008 Teddy Hogeborn and Björn
-# Påhlsson.
-# 
-# This program is free software: you can redistribute it and/or modify
-# it under the terms of the GNU General Public License as published by
-# the Free Software Foundation, either version 3 of the License, or
-# (at your option) any later version.
-#
-#     This program is distributed in the hope that it will be useful,
-#     but WITHOUT ANY WARRANTY; without even the implied warranty of
-#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-#     GNU General Public License for more details.
-# 
-# You should have received a copy of the GNU General Public License
-# along with this program.  If not, see <http://www.gnu.org/licenses/>.
-# 
-# Contact the authors at <https://www.fukt.bsnet.se/~belorn/> and
-# <https://www.fukt.bsnet.se/~teddy/>.
-# 
 
 from __future__ import division
 
@@ -53,8 +24,6 @@
 import subprocess
 import atexit
 import stat
-import logging
-import logging.handlers
 
 import dbus
 import gobject
@@ -62,17 +31,8 @@
 from dbus.mainloop.glib import DBusGMainLoop
 import ctypes
 
-# Brief description of the operation of this program:
-# 
-# This server announces itself as a Zeroconf service.  Connecting
-# clients use the TLS protocol, with the unusual quirk that this
-# server program acts as a TLS "client" while the connecting clients
-# acts as a TLS "server".  The clients (acting as a TLS "server") must
-# supply an OpenPGP certificate, and the fingerprint of this
-# certificate is used by this server to look up (in a list read from a
-# file at start time) which binary blob to give the client.  No other
-# authentication or authorization is done by this server.
-
+import logging
+import logging.handlers
 
 logger = logging.Logger('mandos')
 syslogger = logging.handlers.SysLogHandler\
@@ -84,9 +44,9 @@
 
 # This variable is used to optionally bind to a specified interface.
 # It is a global variable to fit in with the other variables from the
-# Avahi example code.
+# Avahi server example code.
 serviceInterface = avahi.IF_UNSPEC
-# From the Avahi example code:
+# From the Avahi server example code:
 serviceName = "Mandos"
 serviceType = "_mandos._tcp" # http://www.dns-sd.org/ServiceTypes.html
 servicePort = None                      # Not known at startup
@@ -155,8 +115,6 @@
     def __init__(self, name=None, options=None, stop_hook=None,
                  fingerprint=None, secret=None, secfile=None,
                  fqdn=None, timeout=None, interval=-1, checker=None):
-        """Note: the 'checker' argument sets the 'checker_command'
-        attribute and not the 'checker' attribute.."""
         self.name = name
         # Uppercase and remove spaces from fingerprint
         # for later comparison purposes with return value of
@@ -189,7 +147,7 @@
         self.checker_callback_tag = None
         self.check_command = checker
     def start(self):
-        """Start this client's checker and timeout hooks"""
+        """Start this clients checker and timeout hooks"""
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
         self.checker_initiator_tag = gobject.timeout_add\
@@ -205,18 +163,12 @@
         """Stop this client.
         The possibility that this client might be restarted is left
         open, but not currently used."""
-        # If this client doesn't have a secret, it is already stopped.
-        if self.secret:
-            logger.debug(u"Stopping client %s", self.name)
-            self.secret = None
-        else:
-            return False
-        if hasattr(self, "stop_initiator_tag") \
-               and self.stop_initiator_tag:
+        logger.debug(u"Stopping client %s", self.name)
+        self.secret = None
+        if self.stop_initiator_tag:
             gobject.source_remove(self.stop_initiator_tag)
             self.stop_initiator_tag = None
-        if hasattr(self, "checker_initiator_tag") \
-               and self.checker_initiator_tag:
+        if self.checker_initiator_tag:
             gobject.source_remove(self.checker_initiator_tag)
             self.checker_initiator_tag = None
         self.stop_checker()
@@ -225,13 +177,19 @@
         # Do not run this again if called by a gobject.timeout_add
         return False
     def __del__(self):
-        self.stop_hook = None
-        self.stop()
+        # Some code duplication here and in stop()
+        if hasattr(self, "stop_initiator_tag") \
+               and self.stop_initiator_tag:
+            gobject.source_remove(self.stop_initiator_tag)
+            self.stop_initiator_tag = None
+        if hasattr(self, "checker_initiator_tag") \
+               and self.checker_initiator_tag:
+            gobject.source_remove(self.checker_initiator_tag)
+            self.checker_initiator_tag = None
+        self.stop_checker()
     def checker_callback(self, pid, condition):
         """The checker has completed, so take appropriate actions."""
         now = datetime.datetime.now()
-        self.checker_callback_tag = None
-        self.checker = None
         if os.WIFEXITED(condition) \
                and (os.WEXITSTATUS(condition) == 0):
             logger.debug(u"Checker for %(name)s succeeded",
@@ -247,18 +205,12 @@
         else:
             logger.debug(u"Checker for %(name)s failed",
                          vars(self))
+            self.checker = None
+        self.checker_callback_tag = None
     def start_checker(self):
         """Start a new checker subprocess if one is not running.
         If a checker already exists, leave it running and do
         nothing."""
-        # The reason for not killing a running checker is that if we
-        # did that, then if a checker (for some reason) started
-        # running slowly and taking more than 'interval' time, the
-        # client would inevitably timeout, since no checker would get
-        # a chance to run to completion.  If we instead leave running
-        # checkers alone, the checker would have to take more time
-        # than 'timeout' for the client to be declared invalid, which
-        # is as it should be.
         if self.checker is None:
             try:
                 command = self.check_command % self.fqdn
@@ -289,20 +241,13 @@
         return True
     def stop_checker(self):
         """Force the checker process, if any, to stop."""
-        if self.checker_callback_tag:
-            gobject.source_remove(self.checker_callback_tag)
-            self.checker_callback_tag = None
         if not hasattr(self, "checker") or self.checker is None:
             return
-        logger.debug("Stopping checker for %(name)s", vars(self))
-        try:
-            os.kill(self.checker.pid, signal.SIGTERM)
-            #os.sleep(0.5)
-            #if self.checker.poll() is None:
-            #    os.kill(self.checker.pid, signal.SIGKILL)
-        except OSError, error:
-            if error.errno != errno.ESRCH:
-                raise
+        gobject.source_remove(self.checker_callback_tag)
+        self.checker_callback_tag = None
+        os.kill(self.checker.pid, signal.SIGTERM)
+        if self.checker.poll() is None:
+            os.kill(self.checker.pid, signal.SIGKILL)
         self.checker = None
     def still_valid(self, now=None):
         """Has the timeout not yet passed for this client?"""
@@ -315,7 +260,7 @@
 
 
 def peer_certificate(session):
-    "Return the peer's OpenPGP certificate as a bytestring"
+    "Return an OpenPGP data packet string for the peer's certificate"
     # If not an OpenPGP certificate...
     if gnutls.library.functions.gnutls_certificate_type_get\
             (session._c_object) \
@@ -332,7 +277,7 @@
 
 
 def fingerprint(openpgp):
-    "Convert an OpenPGP bytestring to a hexdigit fingerprint string"
+    "Convert an OpenPGP data string to a hexdigit fingerprint string"
     # New empty GnuTLS certificate
     crt = gnutls.library.types.gnutls_openpgp_crt_t()
     gnutls.library.functions.gnutls_openpgp_crt_init\
@@ -397,7 +342,7 @@
             return
         logger.debug(u"Fingerprint: %s", fpr)
         client = None
-        for c in self.server.clients:
+        for c in clients:
             if c.fingerprint == fpr:
                 client = c
                 break
@@ -504,7 +449,7 @@
 
 
 def add_service():
-    """Derived from the Avahi example code"""
+    """From the Avahi server example code"""
     global group, serviceName, serviceType, servicePort, serviceTXT, \
            domain, host
     if group is None:
@@ -529,7 +474,7 @@
 
 
 def remove_service():
-    """From the Avahi example code"""
+    """From the Avahi server example code"""
     global group
     
     if not group is None:
@@ -537,7 +482,7 @@
 
 
 def server_state_changed(state):
-    """Derived from the Avahi example code"""
+    """From the Avahi server example code"""
     if state == avahi.SERVER_COLLISION:
         logger.warning(u"Server name collision")
         remove_service()
@@ -546,7 +491,7 @@
 
 
 def entry_group_state_changed(state, error):
-    """Derived from the Avahi example code"""
+    """From the Avahi server example code"""
     global serviceName, server, rename_count
     
     logger.debug(u"state change: %i", state)
@@ -622,18 +567,13 @@
         sys.exit(status)
 
 
-def main():
-    global exitstatus
+if __name__ == '__main__':
     exitstatus = 0
-    global main_loop_started
     main_loop_started = False
-    
     parser = OptionParser()
     parser.add_option("-i", "--interface", type="string",
                       default=None, metavar="IF",
                       help="Bind to interface IF")
-    parser.add_option("-a", "--address", type="string", default=None,
-                      help="Address to listen for requests on")
     parser.add_option("-p", "--port", type="int", default=None,
                       help="Port number to receive requests on")
     parser.add_option("--timeout", type="string", # Parsed later
@@ -666,13 +606,10 @@
     # Parse config file
     defaults = { "checker": "fping -q -- %%(fqdn)s" }
     client_config = ConfigParser.SafeConfigParser(defaults)
-    #client_config.readfp(open("global.conf"), "global.conf")
+    #client_config.readfp(open("secrets.conf"), "secrets.conf")
     client_config.read("mandos-clients.conf")
     
-    global main_loop
-    global bus
-    global server
-    # From the Avahi example code
+    # From the Avahi server example code
     DBusGMainLoop(set_as_default=True )
     main_loop = gobject.MainLoop()
     bus = dbus.SystemBus()
@@ -710,14 +647,13 @@
     def cleanup():
         "Cleanup function; run on exit"
         global group
-        # From the Avahi example code
+        # From the Avahi server example code
         if not group is None:
             group.Free()
             group = None
         # End of Avahi example code
         
-        while clients:
-            client = clients.pop()
+        for client in clients:
             client.stop_hook = None
             client.stop()
     
@@ -731,20 +667,18 @@
     for client in clients:
         client.start()
     
-    tcp_server = IPv6_TCPServer((options.address, options.port),
+    tcp_server = IPv6_TCPServer((None, options.port),
                                 tcp_handler,
                                 options=options,
                                 clients=clients)
     # Find out what random port we got
-    global servicePort
     servicePort = tcp_server.socket.getsockname()[1]
     logger.debug(u"Now listening on port %d", servicePort)
     
     if options.interface is not None:
-        global serviceInterface
         serviceInterface = if_nametoindex(options.interface)
     
-    # From the Avahi example code
+    # From the Avahi server example code
     server.connect_to_signal("StateChanged", server_state_changed)
     try:
         server_state_changed(server.GetState())
@@ -758,7 +692,6 @@
                          tcp_server.handle_request(*args[2:],
                                                    **kwargs) or True)
     try:
-        logger.debug("Starting main loop")
         main_loop_started = True
         main_loop.run()
     except KeyboardInterrupt:
@@ -766,6 +699,3 @@
             print
     
     sys.exit(exitstatus)
-
-if __name__ == '__main__':
-    main()

